# Specfile for IPLog

%define name	ksm-iplog
%define version	0.0.2
%define release	0.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Logg dynamic given IPs
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Networking/Diagnostic
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	ksm-lib-sh >= 3.0.2-0.5.0
#Provides:	sampled
#Conflicts:	sampled-other,libsample == 0.0.0
#Obsoletes:	mysampled

%description
This package allows logging of dynamically given IPs to the system.

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample.conf
#%attr(644,root,root)%{_confdir}/sample.conf
#%attr(644,root,root)%{_scnfdir}/sample.conf

#%attr(744,root,root)/%{_rcdir}/iplog
#%attr(777,root,root)%{_sbindir}/rcksm-sample
%attr(755,root,root)%{_bindir}/iploglst
%attr(700,root,root)%{_sbindir}/log-dhcp-ip

%{_datadir}/RELEASE
%{_datadir}/VERSION
%attr(744,root,root)%{_datadir}/ksm-iplog.rc
%{_datadir}/ksm-iplog.service

/etc/logrotate.d/ksm-iplog
/var/local/dhcpcd/iplog.txt

#/usr/share/applications/sample.desktop

#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/iploglst.1.gz

%docdir %{_man8dir}
%{_man8dir}/log-dhcp-ip.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
#test -e %{_confdir}/sample.conf && cp %{_confdir}/sample.conf %{_confdir}/sample.conf.rpmsave
#test -e %{_scnfdir}/sample.conf && cp %{_scnfdir}/sample.conf %{_scnfdir}/sample.conf.rpmsave

# disable sample daemon and stop sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall samplename
if [ -d %{_sysddir} ]; then				# systemd
	if [ -e %{_sysddir}/ksm-iplog.service ]; then
		systemctl stop ksm-iplog.service
		systemctl disable ksm-iplog.service
		rm %{_sysddir}/ksm-iplog.service
		systemctl daemon-reload
	fi
else							# SysV init
	test -x %{_rcdir}/ksm-iplog && %{_rcdir}/ksm-iplog stop > /dev/null 2>&1
	insserv -r ksm-iplog
	rm -f %{_rcdir}/ksm-iplog
	rm -f %{_sbindir}/rcksm-iplog
fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/iplog.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# enable iplog daemon
#test -x %{_bindir}/toggleiplog && %{_bindir}/toggleiplog -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/iplog.directory \
#	/usr/share/applications/iplog.desktop \
#	/usr/share/applications/iplog-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - install iplogname
if [ -d %{_sysddir} ]; then				# systemd
	cp --preserve=mode %{_datadir}/ksm-iplog.service %{_sysddir}/
	systemctl daemon-reload
	systemctl enable ksm-iplog.service

	echo "The unit is already added to the bootprocess."
	echo "Next configure the $cf"
	echo "If wanted start it within yast or manual with:"
	echo "systemctl start ksm-iplog.service"
else							# SysV init
	cp --preserve=mode %{_datadir}/ksm-iplog.rc %{_rcdir}/ksm-iplog
	ln -sf %{_rcdir}/ksm-iplog %{_sbindir}/rcksm-iplog
	insserv ksm-iplog

	echo "The script is already added to the bootprocess."
	echo "Next configure the $cf"
	echo "If wanted start it within yast or manual with rcksm-iplog"
fi

if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.iplogrc with update-iplog"

	if [ ! -e /var/local/dhcpcd/iplog ]; then
		cp /dev/null /var/local/dhcpcd/iplog
	fi
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.iplogrc'
#	updcmd="%{_bindir}/update-iplog -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.iplogrc with update-iplog"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/iplog.conf && cp %{_confdir}/iplog.conf %{_confdir}/iplog.conf.rpmsave
	#test -e %{_scnfdir}/iplog.conf && cp %{_scnfdir}/iplog.conf %{_scnfdir}/iplog.conf.rpmsave

	# disable iplog daemon and stop iplogd
	#test -x %{_bindir}/toggleiplog && %{_bindir}/toggleiplog -d -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/iplog.directory \
	#	/usr/share/applications/iplog.desktop \
	#	/usr/share/applications/iplog-admin.desktop

	# INIT SCRIPT/SYSTEMD UNIT - uninstall iplogname
	if [ -d %{_sysddir} ]; then			# systemd
		if [ -e %{_sysddir}/ksm-iplog.service ]; then
			systemctl stop ksm-iplog.service
			systemctl disable ksm-iplog.service
			rm %{_sysddir}/ksm-iplog.service
			systemctl daemon-reload
		fi
	else						# SysV init
		test -x %{_rcdir}/ksm-iplog && %{_rcdir}/ksm-iplog stop > /dev/null 2>&1
		insserv -r ksm-iplog
		rm -f %{_rcdir}/ksm-iplog
		rm -f %{_sbindir}/rcksm-iplog
	fi
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sampledir
#else							# upgrade package
fi
exit 0

%changelog
* Tue Apr 17 2018 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.0.0
- Now the package supports systemd.

* Tue Jan 24 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.2.0
- All scripts have been revised
  (using function GetOpt).

* Sat Nov 12 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.1.0
- All scripts have been revised.

* Sat Jan 30 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.0.0
- Added logfile /etc/logrotate.d/ksm-iplog

* Wed Oct 15 2014 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.2.1
- The docu of the package has been revised.

* Wed Sep 26 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.2.0
- The package has been revised.

* Mon Apr 02 2012 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.1.0
- The release naming scheme has changed ('.ksm' is removed).

* Mon Jan 03 2011 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.1.0.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Tue Mar 23 2010 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.1.0.ksm
- The script log-dhcp-ip is corrected.

* Tue Mar 23 2010 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.0.1.ksm
- The RPM Specfile is corrected.

* Mon Mar 22 2010 Juergen Kaesmann <juergen@kaesman.de> 0.0.1-0.0.0.ksm
- The package has been revised and released for download.

* Mon Mar 22 2010 Juergen Kaesmann <juergen@kaesman.de> 0.0.0-0.0.0.ksm
- First install.
